﻿module CMainController;
import DOpenGL.gl;
import Obelisk.EKey, Obelisk.IMainController, Obelisk.IObelisk, Obelisk.IThread;
import CGameController;

extern (C) IMainController CreateMainController(IObelisk aObelisk)
{
	return new CMainController(aObelisk);
}



class CMainController : IMainController
{
	private IObelisk mObelisk;
	private CGameController mGameController;

	public this(IObelisk aObelisk)
	{
		mObelisk = aObelisk;
		mObelisk.SetSize(1024, 768);
		mObelisk.SetCaption("Lonely Trader");
		mObelisk.SetShaders(true);
	}



	public void Initialise()
	{
		mObelisk.LoadShader("Star.glsl");
		mObelisk.LoadTexture("Ship.png");
		mObelisk.LoadTexture("Thrust.png");
		mObelisk.LoadTexture("Planet0.png");
		//mObelisk.LoadFontImage("D3 Euronism_24.png");
		mObelisk.LoadFontImage("D3 Euronism_20.png");
		mObelisk.LoadTexture("Cursor.png");
		mObelisk.LoadTexture("Minimap.png");

		glFrontFace(GL_CW);
		mGameController = new CGameController(mObelisk);
		mObelisk.StartTimer();
	}



	public void OnTimer()
	{
		if (mGameController !is null)
		{
			mGameController.Update();
			mObelisk.BeginFrame();
			mGameController.Render();
			mObelisk.EndFrame();
		}
	}



	public void OnNotify(int aMessage, int aData)
	{
	}



	public void OnDeactivate()
	{
	}



	public void OnActivate()
	{
	}



	public void OnKeyDown(EKey aKey)
	{
	}



	public void OnKeyUp(EKey aKey)
	{
	}



	public void ThreadFinished(IThread aThread)
	{
	}
}