﻿module CPlanet;
import Obelisk.CColour;
import CGameObject, CView, CViewObject;

class CPlanet : CGameObject
{
	private int[3] mResources;
	private int mProduceResource;
	private int mProduceRate;
	private int mProduction = 0;
	private string mName;

	public this(CView aView, float aX, float aY, int aFuel, int aAmmo, int aShipParts,
			int aProduceResource, int aProduceRate, string aName)
	{
		mViewObject = aView.CreateViewObject(new CViewObject(aX, aY, 0.4, 200, 200, 0, "Planet0.png"));
		mViewObject.MinimapColour = new CColour(0x4F / 255.0f, 0x46 / 255.0f, 0xF9 / 255.0f);
		mResources[0] = aFuel;
		mResources[1] = aAmmo;
		mResources[2] = aShipParts;
		mProduceResource = aProduceResource;
		mProduceRate = aProduceRate;
		mName = aName;
	}



	public void Update()
	{
		if (mProduceResource != -1)
		{
			mProduction += mProduceRate;
			if (mProduction >= 5000)
			{
				mResources[mProduceResource] += mProduction / 5000;
				mProduction %= 5000;
			}
		}
	}



	public int GetProduceResource()
	{
		return mProduceResource;
	}



	public int GetProduceRate() { return mProduceRate; }
	public int GetProduction() { return mProduction; }



	public int GetResource(int aResource)
	{
		return mResources[aResource];
	}



	public void AddResource(int aResource, int aAmount)
	{
		mResources[aResource] += aAmount;
	}



	public string GetName()
	{
		return mName;
	}
}