﻿module Windows.Main;
import core.runtime, std.conv, std.utf, win32.windows;
import Obelisk.IMainController, Shared.CObeliskException, Windows.CApplication;

extern (Windows)
int WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	void exceptionHandler(Throwable e)
	{
		throw e;
	}

	try
	{
		Runtime.initialize(&exceptionHandler);
		CApplication Application = new CApplication(hInstance);
		Application.Run();
		Runtime.terminate(&exceptionHandler);
	}
	catch (CObeliskException oe)
	{
		MessageBoxW(null, toUTF16z(oe.msg), null, MB_ICONERROR);
	}
	catch (Throwable e)
	{
		MessageBoxW(null, cast(wchar*)to!(wstring)("Fatal error: " ~ e.toString() ~ "\0"),
				null, MB_OK | MB_ICONERROR);
	}
	return 0;
}